function [FP,IP,onFP]=FIRPOL2(v1,v2,v3,epsA,borg,IP)
set(gcf,'Pointer','Watch');

if borg==1
    
    [n,h] = size(v1);
    e=ones(n,1);
    sum_v1=v1'*e;
    sum_v2=v2'*e;
    sum_v3=v3'*e;
    B=zeros(n,3);
    m=0;
    for i=1:n
        if  max(abs([v1(i),v2(i),v3(i)]))>1.0e-14
            m=m+1;
            
            B(m,1)=v2(i)-(sum_v2/sum_v1)*v1(i)';
            B(m,2)=v3(i)-(sum_v3/sum_v1)*v1(i)';
            B(m,3)=(-1/sum_v1)*v1(i)-epsA;
            
        end
    end
    test_init=0;
else
    m=0;
    n=size(v1,1);
    for i=1:n
        if  max(abs([v1(i),v2(i),v3(i)]))>1.0e-14
            m=m+1;
            B(m,1)=v2(i);
            B(m,2)=v3(i);
            B(m,3)=-v1(i)-epsA;
    
        end
    end
    test_init=0;
end



%sort data
[m,h]=size(B);

if borg==1
    
    
    
    B=sortrows(B,3);
    b=B(:,3);
    B=B(:,1:2);
    
    %starting triangle
    P(1,:)=[-3,3];
    P(2,:)=[-3,-3];
    P(3,:)=[3,0];
    nP=3;
    nE=3;
    E(1,:)=[1 2];
    E(2,:)=[1 3];
    E(3,:)=[2 3];
    test_init=1;
else
    ind=0;
    ind0=0;
    C=zeros(m,3);
    for i=1:m
        if B(i,1)>1.0e-14
            C(i,1)=1;
            C(i,2)=B(i,2)/B(i,1);
            C(i,3)=B(i,3)/B(i,1);
        elseif B(i,1)<-1.0e-14
            ind=ind+1;
            C(i,1)=-1;
            C(i,2)=-B(i,2)/B(i,1);
            C(i,3)=-B(i,3)/B(i,1);
        else
            ind0=ind0+1;
            C(i,1)=0;
            C(i,2)=B(i,2);
            C(i,3)=B(i,3);
        end
    end
    C=sortrows(C,1);
    
    
    test_min=0;
    test_max=0;
    if ind0>0
        i=ind+1;
        
        while (test_min==0 || test_max==0) && i<=ind+ind0
            if C(i,2)>1.0e-14
                y_min=C(i,3)/C(i,2);
                test_min=1;
            elseif C(i,2)<-1.0e-14
                y_max=C(i,3)/C(i,2);
                test_max=1;
            end
            i=i+1;
        end
    end
    i=1;
    j=ind+ind0+1;
    while i<=ind && (test_min==0 || test_max==0)
        a=C(i,2)+C(j,2);
        b=C(i,3)+C(j,3);
        if a>1.0e-14
            y_min=b/a;
            test_min=1;
        elseif a<-1.0e-14
            y_max=b/a;
            test_max=1;
        end
        j=j+1;
        if j>m
            j=ind+ind0+1;
            i=i+1;
        end
    end
    
    
    if i==ind && (test_min==0 || test_max==0)
        printf('FIRPOL does not exist 1');
    else
        ind=0;
        ind0=0;
        for i=1:m
            if B(i,2)>1.0e-14
                C(i,1)=1;
                C(i,2)=B(i,1)/B(i,2);
                C(i,3)=B(i,3)/B(i,2);
            elseif B(i,2)<-1.0e-14
                ind=ind+1;
                C(i,1)=-1;
                C(i,2)=-B(i,1)/B(i,2);
                C(i,3)=-B(i,3)/B(i,2);
            else
                ind0=ind0+1;
                C(i,1)=0;
                C(i,2)=B(i,2);
                C(i,3)=B(i,3);
            end
        end
        C=sortrows(C,1);
        test_min=0;
        test_max=0;
        if ind0>0
            i=ind+1;
            while(test_min==0 || test_max==0) && i<=ind+ind0
                if C(i,2)>1.0e-14
                    x_min=C(i,3)/C(i,2);
                    test_min=1;
                elseif C(i,2)<-1.0e-14
                    x_max=C(i,3)/C(i,2);
                    test_max=1;
                end
                i=i+1;
            end
        end
        
        
        i=1;
        j=ind+ind0+1;
        while i<=ind && (test_min==0 || test_max==0)
            a=C(i,2)+C(j,2);
            b=C(i,3)+C(j,3);
            if a>1.0e-14
                x_min=b/a;
                test_min=1;
            elseif a<-1.0e-14
                x_max=b/a;
                test_max=1;
            end
            j=j+1;
            if j>m
                j=ind+ind0+1;
                i=i+1;
            end
        end
        
        if (test_min==0 ||  test_max==0)
            printf('FIRPOL does not exist');
        else
            %Start Initialisation
            P(1,:)=[x_min-1,y_min-1];
            P(2,:)=[x_max+1,y_min-1];
            P(3,:)=[x_max+1,y_max+1];
            P(4,:)=[x_min-1,y_max+1];
            nP=4;
            nE=4;
            E(1,:)=[1 2];
            E(2,:)=[2 3];
            E(3,:)=[3 4];
            E(4,:)=[1 4];
            test_init=1;
            
            
        end
    end
    B=sortrows(B,3);
    b=B(:,3);
    B=B(:,1:2);
    
end

if test_init==1
    for i=1:m
        
        S=[];
        nS=0;
                if norm([B(i,:) b(i)],2)>1.0e-14
        for j=1:nP

            if B(i,:)*P(j,:)'-b(i)<0
                nS=nS+1;
                S(nS)=j;

            end
            end
        end
        
        j=1;
        
        if nS>1
            a=0;
            for k=1:nE
                l=0;
                if ismember(E(k,1),S)==1
                    l=l+1;
                end
                if ismember(E(k,2),S)==1
                    l=l+1;
                end
                if l==1
                    a=a+1;
                end
            end
            if a>2
                nS=0;
            end
                    
        end

        new=0;
        
        if nS>0
            while j<=nE

                jtest=1;
                if (ismember(E(j,1),S)==1 && ismember(E(j,2),S)==1) 
                    E(j:(nE-1),:)=E((j+1):nE,:);
                    nE=nE-1;
                    jtest=0;
                    
                    
                elseif ismember(E(j,1),S)==1
                    if (abs(B(i,:)*(P(E(j,2),:)-P(E(j,1),:))')>1.0e-14)
                        t=(b(i)-B(i,:)*P(E(j,1),:)')/(B(i,:)*(P(E(j,2),:)-P(E(j,1),:))');
                        P(nP+1,:)=P(E(j,1),:)+t*(P(E(j,2),:)-P(E(j,1),:));
                        E(j,1)=nP+1;
                        nP=nP+1;
                        new=new+1;
                    elseif norm(P(E(j,1),:)-P(E(j,2)))>1.0e-10
                        P1=P(E(j,1),:);
                        P2=P(E(j,2),:);
                        d1=norm(P1-P2);
                        while d1>10^(-10)
                            if B(i,:)*(P1+P2)'/2-b(i)>-1.0e-14
                                P2=(P1+P2)/2;
                            else
                                P1=(P1+P2)/2;
                            end
                            d1=d1/2;
                        end
                        P(nP+1,:)=P2;
                        E(j,1)=nP+1;
                        nP=nP+1;
                        new=new+1;
                    end
                    
                elseif ismember(E(j,2),S)==1
                    if abs(B(i,:)*(P(E(j,2),:)-P(E(j,1),:))')>1.0e-14
                        t=(b(i)-B(i,:)*P(E(j,1),:)')/(B(i,:)*(P(E(j,2),:)-P(E(j,1),:))');
                        P(nP+1,:)=P(E(j,1),:)+t*(P(E(j,2),:)-P(E(j,1),:));
                        E(j,2)=nP+1;
                        nP=nP+1;
                        new=new+1;
                      elseif norm(P(E(j,1),:)-P(E(j,2)))>1.0e-10
                        P1=P(E(j,1),:);
                        P2=P(E(j,2),:);
                        d2=norm(P1-P2);
                        while d2>10^(-10)
                            if B(i,:)*(P1+P2)'/2-b(i)>-1.0e-14
                                P1=(P1+P2)/2;
                            else
                                
                                P2=(P1+P2)/2;
                            end
                            d2=d2/2;
                        end
                        P(nP+1,:)=P1;
                        E(j,2)=nP+1;
                        nP=nP+1;
                        new=new+1;
                    end
                end
                
                if jtest==1
                    
                    
                    
                    min1=0;
                    min2=0;
                    for k=1:nS
                        if S(k)<E(j,1)
                            min1=min1+1;
                        end
                        if S(k)<E(j,2)
                            min2=min2+1;
                        end
                    end
                    E(j,1)=E(j,1)-min1;
                    E(j,2)=E(j,2)-min2;
                    j=j+1;
                    
                end
            end
            
           
           
            for j=nS:-1:1
                
                P(S(j):(nP-1),:)=P((S(j)+1):nP,:);
                nP=nP-1;
            end
            if nS>0
                nE=nE+1;
                E(nE,1)=nP;
                E(nE,2)=nP-1;
            end

        end
        
    end
    P=P(1:nP,:);
    k=convhull(P(:,1),P(:,2),'simplify', true);
    [m,n]=size(k);
    for i=1:(m-1)
        FP(i,:)=P(k(i),:);
    end
    
    [x_min,x_min_ind]=min(FP(:,1));
    k=find(FP(:,1)==x_min);
    [numb_x_min,h]=size(k);
    if numb_x_min>1
        for i=2:numb_x_min
            if FP(x_min_ind,2)>FP(k(i),2)
                x_min_ind=k(i);
            end
        end
    end
    
    if x_min_ind>1
        h=zeros(x_min_ind-1,2);
        h=FP(1:(x_min_ind-1),1:2);
        FP(1:(m-x_min_ind),:)=FP(x_min_ind:(m-1),:);
        FP((m-x_min_ind+1):(m-1),:)=h;
    end
    
else
    FP=[];
end


onFP=[];


im=size(IP,1);
fm=size(FP,1);
i=1;
while i<=fm
    if(norm(FP(i,:)-FP(mod(i,fm)+1,:),2))<1.0e-14
        FP(i:fm-1,:)=FP(i+1:fm,:);
        fm=fm-1;
    

    else

        i=i+1;

    end
end
FP=FP(1:fm,:);
test=0;
i=1;
n=zeros(2,1);

while test<=fm
   n(1)=FP(mod(i-2,fm)+1,2)-FP(mod(i,fm)+1,2);
   n(2)=FP(mod(i,fm)+1,1)-FP(mod(i-2,fm)+1,1);
   n=n/norm(n,2);
   c=FP(mod(i,fm)+1,1:2)*n;
   d=FP(i,1:2)*n-c;
   if abs(d)<1.0e-14
       test=0;
       if i<fm
            FP(i:fm-1,:)=FP(i+1:fm,:);
       end
       fm=fm-1;
       FP=FP(1:fm,:);
   else
       test=test+1;
   end
   i=mod(i,fm)+1;
end

[x_min,x_min_ind]=min(FP(:,1));
k=find(FP(:,1)==x_min);
[numb_x_min,h]=size(k);
x_min_ind=k(1);
if numb_x_min>1
    for i=2:numb_x_min
        if FP(x_min_ind,2)>FP(k(i),2)
            x_min_ind=k(i);
        end
    end
end
m=size(FP,1);
if x_min_ind>1
    h=FP(1:(x_min_ind-1),1:2);
    FP(1:(m+1-x_min_ind),:)=FP(x_min_ind:m,:);
    FP((m-x_min_ind+2):m,:)=h;
end


on=0;
onFP=[];

for i=1:im
    if min(abs(B(:,1:2)*IP(i,1:2)'-b))<1.0e-6
        
        j=1;
        test=0;
        while j<=fm  && test<2
            if norm(IP(i,1:2)-FP(j,1:2),2)<1.0e-10
                if test==1
                    on=on-1;
                end
                test=2;
                
                on=on+1;
                onFP(on,1)=i;
                onFP(on,2)=mod(j-2,fm)+1;
                on=on+1;
                onFP(on,1)=i;
                onFP(on,2)=j;
            else
                v=IP(i,1:2)-FP(j,1:2);
                w=FP(mod(j,fm)+1,1:2)-FP(j,1:2);
                phi=acos(v*w'/(norm(v,2)*norm(w,2)));
                
                if phi<1.0e-3 %&& norm(v)<norm(w)
                    
                    on=on+1;
                    onFP(on,1)=i;
                    onFP(on,2)=j;
                    test=test+1;
                end
            end
            
            j=j+1;
            
            
        end
        
        
    end
end